#include <bits/stdc++.h>
using namespace std;
#define ll long long
//#define mod 998244353


int main()
{

    ll N,M,c;
    scanf("%lld%lld",&N,&M);
    ll b[M],a[N];
    for(int i=1; i<=M; i++)
        scanf("%lld",&b[i]);
    for(int i=1; i<=N; i++)
        for(int j=1; j<=M; j++)
            a[i+b[j]]=a[i+j];
    ll sol=0;
    for(int i=1; i<=N; i++)
    {
        sol+=(pow(c,i)*a[i]);
    }
    printf("%lld",sol);


    return 0;
}